/* Générateur de code morse
   Cette application va vous permettre d'envoyer des messages (reçus via le port série de la platine "Flip & Click")
   en morse via un signal lumineux (led C au dos de la platine).
 
   CE PROGRAMME EST FOURNI «TEL QUEL», SANS GARANTIE D'AUCUNE SORTE, EXPLICITE OU
   IMPLICITE, Y COMPRIS MAIS SANS S'Y LIMITER LES GARANTIES DE QUALITÉ MARCHANDE,
   D'ADAPTATION À UN USAGE PARTICULIER ET D'ABSENCE DE CONTREFAÇON. EN AUCUN CAS, LA
   RESPONSABILITE DES AUTEURS OU DES DÉTENTEURS DE DROITS D'AUTEUR NE SERONT TENUS 
   RESPONSABLES DE TOUTE RECLAMATION, DOMMAGE OU AUTRE RESPONSABILITÉ, QUE CE SOIT
   DANS UNE ACTION DE CONTRAT, TORT OU AUTREMENT, PROVENANT DE, OU EN RELATION AVEC
   CE PROGRAMME OU L'UTILISATION OU AUTRES TRAITEMENTS DU PROGRAMME.
    
*/

const byte morse[]= {5,0b11111000,5,0b01111000,5,0b00111000,5,0b00011000,5,0b00001000,5,0b00000000,5,0b10000000,5,0b11000000,5,0b11100000,5,0b11110000,  // Définition chiffres 0 à 9
2,0b01000000,4,0b10000000,4,0b10100000,3,0b10000000,1,0b00000000,4,0b00100000,3,0b11000000,4,0b00000000,2,0b00000000,                                    // Définition lettres A à I
4,0b01110000,3,0b10100000,4,0b01000000,2,0b11000000,2,0b10000000,3,0b11100000,4,0b01100000,4,0b11010000,3,0b01000000,                                    // Définition lettres J à R 
3,0b00000000,1,0b10000000,3,0b00100000,4,0b00010000,3,0b01100000,4,0b10010000,4,0b10110000,4,0b11000000};                                                // Définition lettres S à Z 

const byte LedC = 39;                                           // Association de la Led C au port 39
byte k,pointrait;                                               // Variables d'usage général
char recu[13];                                                  // Buffer de reception des messages séries
 
void setup() 
{  
  Serial.begin(9600);                                           // Initialisation du port série
  pinMode(LedC, OUTPUT);                                        // Port Led C en sortie pour pilotage de la led
  digitalWrite(LedC, LOW);                                      // Eteint la led 
}

void loop() 
{
   k = 0 ;                                                      // Attente et récupération des messages séries
   while (Serial.available() > 0) {
      recu[k] = Serial.read(); 
      k++;   
    delay(10); }  

  if (k > 0)                                                    // Regarde si on a reçu un message à envoyer
    {
    for (byte j=0; j<k; j++) {                                  // Envoi un à un les caractères en code morse
        if (recu[j] >= 48 & recu[j]<=57){                       // Regarde si on a reçu un chiffre compris entre 0 et 9 (code ASCII 48 à 57)
           pointrait = morse[((recu[j]-48)*2)+1];               // Récupère la codification du chiffre à envoyer
           for (byte l=0; l<morse[(recu[j]-48)*2]; l++) {       // Boucle correspondante au nombre de caractères (en morse) composant le chiffre à envoyer
              if (bitRead(pointrait,7) == 0)                    // Regarde si on envoi un point ?
                {point();}                                      // Oui -> Génère un point (via la led)
              else
                {trait();}                                      // Non -> Génère un trait (via la led)
              pointrait = pointrait << 1;                       // Récupère codification suivante
           }
        }

         if (recu[j] >= 65 & recu[j]<=90){                      // Regarde si on a reçu une lettre comprise entre A et Z (code ASCII 65 à 90)
           pointrait = morse[((recu[j]-65)*2)+21];              // Récupère la codification de la lettre à envoyer
           for (byte l=0; l<morse[((recu[j]-65)*2)+20]; l++) {  // Boucle correspondante au nombre de caractères (en morse) composant le chiffre à envoyer
              if (bitRead(pointrait,7) == 0)                    // Regarde si on envoi un point ?
                {point();}                                      // Oui -> Génère un point (via la led)
              else
                {trait();}                                      // Non -> Génère un trait (via la led)
              pointrait = pointrait << 1;                       // Récupère codification suivante
           }
        }       
      delay(400);                                                // Temporisation entre les caractères morses envoyés
      }
   }
}
 
//--------------------------------------------- Fonctions -------------------------------------------

    void point() {
    digitalWrite(LedC, HIGH);                   // Génération d'un "Point"
    delay(230);
    digitalWrite(LedC, LOW);                    // Eteint la led 
    delay(250);
    }

    void trait() {
    digitalWrite(LedC, HIGH);                   // Génération d'un "Trait"
    delay(900);
    digitalWrite(LedC, LOW);                    // Eteint la led 
    delay(250);
    }
     
