/* Pilotage d'un servomoteur
   Cette application va vous permettre de piloter un petit servomoteur (type modelisme)
   à partir d'une résistance ajustable.
  
   CE PROGRAMME EST FOURNI «TEL QUEL», SANS GARANTIE D'AUCUNE SORTE, EXPLICITE OU
   IMPLICITE, Y COMPRIS MAIS SANS S'Y LIMITER LES GARANTIES DE QUALITÉ MARCHANDE,
   D'ADAPTATION À UN USAGE PARTICULIER ET D'ABSENCE DE CONTREFAÇON. EN AUCUN CAS, LA
   RESPONSABILITE DES AUTEURS OU DES DÉTENTEURS DE DROITS D'AUTEUR NE SERONT TENUS 
   RESPONSABLES DE TOUTE RECLAMATION, DOMMAGE OU AUTRE RESPONSABILITÉ, QUE CE SOIT
   DANS UNE ACTION DE CONTRAT, TORT OU AUTREMENT, PROVENANT DE, OU EN RELATION AVEC
   CE PROGRAMME OU L'UTILISATION OU AUTRES TRAITEMENTS DU PROGRAMME. CE PROGRAMME 
   EST PUBLIE SOUS LICENCE GNU GPL.
    
*/

#include <Servo.h>                          // Fait appel à la librairie "Servo"     
Servo Monservo;                             // Création objet pour contrôler le servomoteur
  
const byte Rajustable = A5;                 // N° du port sur lequel est relié la résistance ajustable
int valeur;                                 // Variable utilisée pour lire la tension de la résistance ajustable
  
void setup() 
{ 
  Monservo.attach(8);                       // Associe le servomoteur à la broche 8 de la platine "Flip & Click" 
} 
  
void loop() 
{ 
  valeur = analogRead(Rajustable);          // Conversion analogique/numérique de la résistance ajustable (valeur retournée 0 à 1023)          
  valeur = map(valeur, 0, 1023, 0, 179);    // Mise à l'échelle pour disposer d'une valeur acceptée par le servomoteur (comprise entre 0 et 179)    
  Monservo.write(valeur);                   // Positionne le servomoteur sur la position chosie avec la résistanceajustable  
  delay(20);                                // Temporisation pour permettre au servomoteur de se rendre à cette position  
}
