/* Thermomètre à affichage sur LCD
   Cette application va vous permettre de réalise un petit thermomètre
   sur écran LCD à partir d'un capteur de type LM35
 
   CE PROGRAMME EST FOURNI «TEL QUEL», SANS GARANTIE D'AUCUNE SORTE, EXPLICITE OU
   IMPLICITE, Y COMPRIS MAIS SANS S'Y LIMITER LES GARANTIES DE QUALITÉ MARCHANDE,
   D'ADAPTATION À UN USAGE PARTICULIER ET D'ABSENCE DE CONTREFAÇON. EN AUCUN CAS, LA
   RESPONSABILITE DES AUTEURS OU DES DÉTENTEURS DE DROITS D'AUTEUR NE SERONT TENUS 
   RESPONSABLES DE TOUTE RECLAMATION, DOMMAGE OU AUTRE RESPONSABILITÉ, QUE CE SOIT
   DANS UNE ACTION DE CONTRAT, TORT OU AUTREMENT, PROVENANT DE, OU EN RELATION AVEC
   CE PROGRAMME OU L'UTILISATION OU AUTRES TRAITEMENTS DU PROGRAMME. CE PROGRAMME 
   EST PUBLIE SOUS LICENCE GNU GPL.
    
*/

#include <LiquidCrystal.h>                // Ajout de la librairie permettant de gérer l'afficheur LCD
LiquidCrystal lcd(11, 12, 7, 8, 9, 10);   // Attribution des broches de la platine destinées à piloter l'afficheur
int Temperature;                          // Variable pour la mesure de la température 
const byte LM35 = A5;                     // Attribution de la sortie du LM35 au port A5
     
void setup()
{
lcd.begin(16, 2);                         // Déclaration d'un afficheur LCD doté de 2 lignes de 16 caractères
lcd.clear();                              // Efface l'écran et place le curseur en haut à gauche 
lcd.print("La temperature  ");            // Affichage du message "La température"
lcd.setCursor(0, 1);                      // Place le curseur sur la 2ème ligne en bas à gauche
lcd.print("est de:       C ");             // Affichage du message "est de:   C"
}

void loop()
{
Temperature = analogRead(LM35);           // Mesure la tension à la sortie du LM35
float millivolt = (Temperature/1023.0)*3200;   // Conversion de la tension en température
float celcius = millivolt/10;
lcd.setCursor(8, 1);                      // Place le curseur sur la 2ème ligne au milieu de l'écran
lcd.print(celcius);                       // Affiche la température sur l'écran LCD     
delay(1000);                              // Temporisation entre 2 mesures
}
