/* Utilisation du module MIKROE-1993
   Cette application va vous permettre de réaliser un sablier dont le sable est matérialisé par les
   leds de la matrice du module "7x10 R Click" (à mettre sur le support A de la platine "Flip & Click").
      
   CE PROGRAMME EST FOURNI «TEL QUEL», SANS GARANTIE D'AUCUNE SORTE, EXPLICITE OU
   IMPLICITE, Y COMPRIS MAIS SANS S'Y LIMITER LES GARANTIES DE QUALITÉ MARCHANDE,
   D'ADAPTATION À UN USAGE PARTICULIER ET D'ABSENCE DE CONTREFAÇON. EN AUCUN CAS, LA
   RESPONSABILITE DES AUTEURS OU DES DÉTENTEURS DE DROITS D'AUTEUR NE SERONT TENUS 
   RESPONSABLES DE TOUTE RECLAMATION, DOMMAGE OU AUTRE RESPONSABILITÉ, QUE CE SOIT
   DANS UNE ACTION DE CONTRAT, TORT OU AUTREMENT, PROVENANT DE, OU EN RELATION AVEC
   CE PROGRAMME OU L'UTILISATION OU AUTRES TRAITEMENTS DU PROGRAMME.
 
*/

#include <SPI.h>                      // Intégration de la librairie SPI
#define CS0 77                        // Attribution du signal CS0 au port 77
#define RCLK 54                       // Attribution du signal RCLK au port 54
#define MR 33                         // Attribution du signal MR au port 33
#define RST 6                         // Attribution du signal RST au port 6

// Définition du sablier
byte Matrice[2][7] ={{0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b000000000,0b00000000},
                    {0b00000011,0b00000111,0b00001111,0b00011111,0b00001111,0b000000111,0b00000011}};
                           
void setup() {
  pinMode(CS0, OUTPUT);               // La broche CS0 est une sortie
  pinMode(RCLK, OUTPUT);              // La broche RCLK est une sortie
  pinMode(MR, OUTPUT);                // La broche MR est une sortie
  pinMode(RST, OUTPUT);               // La broche RST est une sortie
  digitalWrite(MR, HIGH);             // Force la broche MR au niveau logique haut
  digitalWrite(RCLK, LOW);            // Niveau logique bas sur l'horloge du 4017 du module 7x10 R click
  digitalWrite(RST, LOW);             // Niveau logique bas sur l'entrée de RESET du 4017 du module 7x10 R click
  SPI.begin();                        // Initialiation du port SPI
}

void loop() 
{        
    for (byte sablier = 0 ; sablier < 5 ; sablier++){    // Boucle gérant l'écoulement du sablier
       for (int Tempo = 0 ; Tempo < 100 ; Tempo++) {Rmatrice();}      // Boucle générant une temporisation avec un rafraichissement de la matrice
       for (byte i = 0 ; i < 7; i++) {bitWrite(Matrice[0][i],4-sablier,bitRead(Matrice[1][i],sablier));}  // Boucle déversant led matrices du haut vers matrice du bas
       for (byte i = 0 ; i < 7; i++) {bitWrite(Matrice[1][i],sablier,0);}        // Boucle effaçant le sable des lignes du haut du sablier 
    }
    while(1)                           // Fin de la durée d'écoulement -> Entre dans une boucle sans fin
    {Rmatrice();}                      // Dans laquelle on rafraichit constamment la matrice 
}

void Rmatrice() {                      // Fonction permettant de rafraichir la matrice
   digitalWrite(RST, HIGH);            // Reset du 4017 du module 7x10 R click
   digitalWrite(RST, LOW);
   for (byte i = 0 ; i < 7; i++){      // Boucle générant 7 coups d'horloge sur le 4017 
     digitalWrite(CS0, LOW);           // Sélection broche CSO    
     SPI.transfer(Matrice[0][i]);      // Envoie les données de la première partie de la matrice
     SPI.transfer(Matrice[1][i]);      // Envoie les données de la deuxième partie de la matrice  
     digitalWrite(CS0, HIGH);          // Dé-sélection de la broche CS0 
     delay(2);
     digitalWrite(MR, LOW);            // Vide le registre à décalage des 74HC595
     digitalWrite(MR, HIGH);          
     digitalWrite(RCLK, HIGH);         // Coup d'horloge sur le 4017 du module 7x10 R click
     digitalWrite(RCLK, LOW);}
     digitalWrite(CS0, LOW);           // Sélection broche CSO    
     SPI.transfer(Matrice[0][0]);      // Envoie les données de la première partie de la matrice
     SPI.transfer(Matrice[1][0]);      // Envoie les données de la deuxième partie de la matrice  
     digitalWrite(CS0, HIGH);          // Désélection de la broche CS0    
}     
     
