/* Utilisation du module MIKROE-1993
   Cette application va vous permettre de réaliser un mini jeu de tennis (1 joueur - contre le mur) à l'aide
   de la matrice du module "7x10 R Click" (à mettre sur le support A de la platine "Flip & Click").
      
   CE PROGRAMME EST FOURNI «TEL QUEL», SANS GARANTIE D'AUCUNE SORTE, EXPLICITE OU
   IMPLICITE, Y COMPRIS MAIS SANS S'Y LIMITER LES GARANTIES DE QUALITÉ MARCHANDE,
   D'ADAPTATION À UN USAGE PARTICULIER ET D'ABSENCE DE CONTREFAÇON. EN AUCUN CAS, LA
   RESPONSABILITE DES AUTEURS OU DES DÉTENTEURS DE DROITS D'AUTEUR NE SERONT TENUS 
   RESPONSABLES DE TOUTE RECLAMATION, DOMMAGE OU AUTRE RESPONSABILITÉ, QUE CE SOIT
   DANS UNE ACTION DE CONTRAT, TORT OU AUTREMENT, PROVENANT DE, OU EN RELATION AVEC
   CE PROGRAMME OU L'UTILISATION OU AUTRES TRAITEMENTS DU PROGRAMME.
    
*/

#include <SPI.h>                                      // Intégration de la librairie SPI
#define CS0 77                                        // Attribution du signal CS0 au port 77
#define RCLK 54                                       // Attribution du signal RCLK au port 54
#define MR 33                                         // Attribution du signal MR au port 33
#define RST 6                                         // Attribution du signal RST au port 6
#define Rajustable 55                                 // N° du port sur lequel est relié la résistance ajustable

byte Matrice[2][7];                                   // Définition de la matrice (aire de jeu)
byte PosRaquette;                                     // Définition de la position initiale de la raquette 
byte Decompte,Vitesse=20;                             // Variables gérant la vitesse de déplacement de la balle
byte MBall=0, xBall, yBall=3, DxBall=1, DyBall=1;     // Variables pour la gestion de la balle

                              
void setup() {
  pinMode(CS0, OUTPUT);pinMode(RCLK, OUTPUT);         // Les broches CS0 et RCLK sont des sorties
  pinMode(MR, OUTPUT);pinMode(RST, OUTPUT);           // Les broches MR et RST sont des sorties
  digitalWrite(MR, HIGH);                             // Force la broche MR au niveau logique haut
  digitalWrite(RCLK, LOW);                            // Niveau logique bas sur l'horloge du 4017 du module 7x10 R click
  digitalWrite(RST, LOW);                             // Niveau logique bas sur l'entrée de RESET du 4017 du module 7x10 R click
  SPI.begin();                                        // Initialiation du port SPI
  for (byte i = 0 ; i < 7; i++)                       // Efface toutes les leds de la matrice
  {Matrice[0][i]=0;Matrice[1][i]=0;}
  randomSeed(analogRead(56));                         // Réinitialise la séquence aléatoire
  xBall=random(1,6);                                  // Positionnement aléatoire la ba balle
  bitSet(Matrice[MBall][xBall],yBall);                // Affiche position initiale de la balle  
  Decompte=Vitesse;                                   // Initialise la vitesse de déplacement de la balle
}

void loop() {        
   //---------------------------------- Gestion du déplacement de la raquette -----------------------------
   
   PosRaquette= analogRead(Rajustable)/100;
   if (PosRaquette < 1) PosRaquette=1; if (PosRaquette > 6) PosRaquette=6;         // Limite le déplacement de la raquette
   bitSet(Matrice[0][PosRaquette],4);bitSet(Matrice[0][PosRaquette-1],4);          // Configure les bits de la raquette à "1"
   bitClear(Matrice[0][PosRaquette+1],4);bitClear(Matrice[0][PosRaquette-2],4);    // Configure les bits autour de la raquette à "0"
   
   //---------------------------------- Gestion du déplacement de la balle -----------------------------

   Decompte--;                                                      // Décompte temporisation pour déterminer la vitesse de déplacement de la balle 
   if (Decompte == 0)                                               // Regarde si on déplace la balle
     {Decompte=Vitesse; bitClear(Matrice[MBall][xBall],yBall);      // Réinitialise le compteur et efface l'ancienne position de la balle
     if (DxBall==1)                                                 // Test collision balle avec les murs de droite et gauche 
       {xBall--;if(xBall==255){xBall=1;DxBall=0;}}                  // Collision mur de droite -> Inverse sens de déplacement
     else
       {xBall++;if(xBall==7)  {xBall=5;DxBall=1;}}                  // Collision mur de droite -> Inverse sens de déplacement    
     if (DyBall==1)                                                 // Teste collision balle avec le mur du haut et déplacement entre les matrices 
       {yBall--; if (yBall==255 & MBall==0) {MBall=1;yBall=4;}      // Teste passage matrice basse vers matrice haute
       if (yBall==255 & MBall==1) {yBall=1;DyBall=0;}}              // Teste collision avec mur du haut
     else
      {yBall++; if (yBall==5 & MBall==1) {MBall=0;yBall=0;}         // Teste passage matrice du haut vers matrice du bas             
       if (yBall==4 & MBall==0 & bitRead(Matrice[0][xBall],4)==1)   // Teste rebond avec la raquette 
         {Vitesse--;if (Vitesse<5) Vitesse=5;DyBall=1;yBall=2;}     // Augmente la vitesse de la balle 
       else
         if (yBall==4 & MBall==0 & bitRead(Matrice[0][xBall],4)==0)  // Teste balle perdue
         {for (byte i = 0 ; i < 5; i++){                             // Clignotement de la balle
         bitSet(Matrice[MBall][xBall],yBall);for (byte i = 0 ; i < 9; i++){Rmatrice();}       
         bitClear(Matrice[MBall][xBall],yBall);for (byte i = 0 ; i < 9; i++){Rmatrice();}}
         for (byte i = 0 ; i < 100; i++)                           // Annimation fin de partie
         {bitSet(Matrice[random(0,2)][random(0,7)],random(0,5));bitSet(Matrice[random(0,2)][random(0,7)],
         random(0,5));bitSet(Matrice[random(0,2)][random(0,7)],random(0,5));Rmatrice();}
         for (byte i = 0 ; i < 150; i++) {bitClear(Matrice[random(0,2)][random(0,7)],random(0,5));bitClear(Matrice[random(0,2)][random(0,7)],random(0,5));
         bitClear(Matrice[random(0,2)][random(0,7)],random(0,5));bitClear(Matrice[random(0,2)][random(0,7)],random(0,5));Rmatrice();}
         while(1)  {Rmatrice();}}}}
   bitSet(Matrice[MBall][xBall],yBall);                              // Mémorise nouvelle position de la balle  
   Rmatrice();}                                                      // Rafraîchissement de la matrice 

void Rmatrice() {// Fonction permettant de rafraichir la matrice
     digitalWrite(RST, HIGH);digitalWrite(RST, LOW);                 // Reset du 4017 du module 7x10 R click
     for (byte i = 0 ; i < 7; i++){                                  // Boucle générant 7 coups d'horloge sur le 4017 
     digitalWrite(CS0, LOW);                                         // Sélection broche CSO    
     SPI.transfer(Matrice[0][i]); SPI.transfer(Matrice[1][i]);       // Envoi les données aux matrices
     digitalWrite(CS0, HIGH);delay(3);                               // Dé-sélection de la broche CS0 
     digitalWrite(MR, LOW);digitalWrite(MR, HIGH);                   // Vide le registre à décalage des 74HC595          
     digitalWrite(RCLK, HIGH);digitalWrite(RCLK, LOW);}              // Coup d'horloge sur le 4017 du module 7x10 R click
     digitalWrite(CS0, LOW);SPI.transfer(Matrice[0][0]); SPI.transfer(Matrice[1][0]);digitalWrite(CS0, HIGH);}

     
