/* Utilisation du module MIKROE-1993
   Cette application va vous permettre de réaliser le jeu  "Pierre - Feuille - Ciseau" à l'aide
   de la matrice du module "7x10 R Click" (à mettre sur le support A de la platine "Flip & Click").
  
   CE PROGRAMME EST FOURNI «TEL QUEL», SANS GARANTIE D'AUCUNE SORTE, EXPLICITE OU
   IMPLICITE, Y COMPRIS MAIS SANS S'Y LIMITER LES GARANTIES DE QUALITÉ MARCHANDE,
   D'ADAPTATION À UN USAGE PARTICULIER ET D'ABSENCE DE CONTREFAÇON. EN AUCUN CAS, LA
   RESPONSABILITE DES AUTEURS OU DES DÉTENTEURS DE DROITS D'AUTEUR NE SERONT TENUS 
   RESPONSABLES DE TOUTE RECLAMATION, DOMMAGE OU AUTRE RESPONSABILITÉ, QUE CE SOIT
   DANS UNE ACTION DE CONTRAT, TORT OU AUTREMENT, PROVENANT DE, OU EN RELATION AVEC
   CE PROGRAMME OU L'UTILISATION OU AUTRES TRAITEMENTS DU PROGRAMME.
    
*/

#include <SPI.h>                                      // Intégration de la librairie SPI
#define CS0 77                                        // Attribution du signal CS0 au port 77
#define RCLK 54                                       // Attribution du signal RCLK au port 54
#define MR 33                                         // Attribution du signal MR au port 33
#define RST 6                                         // Attribution du signal RST au port 6
#define BP1 7                                         // N° du port sur lequel est relié le BP 'Pierre'
#define BP2 27                                        // N° du port sur lequel est relié le BP 'Feuille'
#define BP3 17                                        // N° du port sur lequel est relié le BP 'Ciseau'

                            
const byte MScore[11][7] ={{0b00000000,0b00001110,0b00001010,0b00001010,0b00001010,0b00001110,0b00000000},   // Zéro
                          {0b00000000,0b00000100,0b00000110,0b00000100,0b00000100,0b00001110,0b00000000},    // Un
                          {0b00000000,0b00001110,0b00001000,0b00001110,0b00000010,0b00001110,0b00000000},    // Deux
                          {0b00000000,0b00001110,0b00001000,0b00001100,0b00001000,0b00001110,0b00000000},    // Trois
                          {0b00000000,0b00001010,0b00001010,0b00001110,0b00001000,0b00001000,0b00000000},    // Quatre
                          {0b00000000,0b00001110,0b00000010,0b00001110,0b00001000,0b00001110,0b00000000},    // Cinq
                          {0b00000000,0b00000000,0b00000110,0b00001110,0b00001100,0b00000000,0b00000000},    // Pierre
                          {0b00000000,0b00001110,0b00001110,0b00001110,0b00001110,0b00001110,0b00000000},    // Feuille
                          {0b00001010,0b00001010,0b00001010,0b00000100,0b00000100,0b00001010,0b00001010},    // Ciseau
                          {0b00000000,0b00001111,0b00000001,0b00001101,0b00001001,0b00001111,0b00000000},    // Lettre G
                          {0b00000000,0b00010111,0b00010101,0b00010101,0b00000101,0b00010111,0b00000000}};   // Lettres O!                                                    
                           
byte Matrice[2][7];                                   // Définition de la matrice (aire de jeu)
byte ScoreJ1=0,ScoreJ2=0;                             // Score Joueur 1 (Flip & Click) et Joueur 2 (Vous)
byte MainJ1,MainJ2;                                   // Mains des joueurs
                              
void setup() {
  randomSeed(analogRead(57));                         // Réinitialise la séquence aléatoire
  pinMode(CS0, OUTPUT);pinMode(RCLK, OUTPUT);         // Les broches CS0 et RCLK sont des sorties
  pinMode(MR, OUTPUT);pinMode(RST, OUTPUT);           // Les broches MR et RST sont des sorties
  digitalWrite(MR, HIGH);                             // Force la broche MR au niveau logique haut
  digitalWrite(RCLK, LOW);                            // Niveau logique bas sur l'horloge du 4017 du module 7x10 R click
  digitalWrite(RST, LOW);                             // Niveau logique bas sur l'entrée de RESET du 4017 du module 7x10 R click
  pinMode(BP1, INPUT);                                // Configure le port sur lequel est relié le bouton-Poussoir 1 en entrée
  pinMode(BP2, INPUT);                                // Configure le port sur lequel est relié le bouton-Poussoir 2 en entrée
  pinMode(BP3, INPUT);                                // Configure le port sur lequel est relié le bouton-Poussoir 3 en entrée
  SPI.begin();                                        // Initialiation du port SPI
}

void loop() { 
  AffScore(ScoreJ1,ScoreJ2);                          // Affiche le score du début de la partie
  for (byte i = 0 ; i < 7; i++){Matrice[0][i]=MScore[10][i];Matrice[1][i]=MScore[9][i]; }  // Place mot 'GO !' dans la matrice
  while(digitalRead(BP1) == HIGH & digitalRead(BP2) == HIGH & digitalRead(BP3) == HIGH){   // Tant qu'on a pas sollicité un des boutons-poussoirs
    Rmatrice();                                       // Rafraichissement de la matrice
  }

 if (digitalRead(BP1) == LOW) MainJ2 = 6;             // On a sollicité le bouton 'Pierre'
 if (digitalRead(BP2) == LOW) MainJ2 = 7;             // On a sollicité le bouton 'Feuille'
 if (digitalRead(BP3) == LOW) MainJ2 = 8;             // On a sollicité le bouton 'Ciseau'
 MainJ1 = random(6,9);                                // La platine Flip & Click choisi un signe aléatoirement
 AffScore(MainJ1,MainJ2);                             // Affiche les signes sur les matrices


 if (MainJ1 == MainJ2) {EffMatrice(MainJ1,MainJ2,0,1);AffScore(ScoreJ1,ScoreJ2);}else{ 
   switch (MainJ1) {
    case 6:                                           // La platine Flip & Click a choisi le signe Pierre
      if (MainJ2 == 7) {EffMatrice(MainJ1,MainJ2,1,1);ScoreJ2++;}else{EffMatrice(MainJ1,MainJ2,0,0);ScoreJ1++;}
      break;
    case 7:                                           // La platine Flip & Click a choisi le signe Pierre
      if (MainJ2 == 8) {EffMatrice(MainJ1,MainJ2,1,1);ScoreJ2++;}else{EffMatrice(MainJ1,MainJ2,0,0);ScoreJ1++;}
      break;
    case 8:                                           // La platine Flip & Click a choisi le signe Pierre
      if (MainJ2 == 6) {EffMatrice(MainJ1,MainJ2,1,1);ScoreJ2++;}else{EffMatrice(MainJ1,MainJ2,0,0);ScoreJ1++;}
      break;}}
  AffScore(ScoreJ1,ScoreJ2);                          // Affiche le score
  if (ScoreJ1 == 5 || ScoreJ2 == 5)  CligneScore();}  // Regarde si un des joueur est arrivé à 5
                                                                             

void Rmatrice() {                                                                                                // Fonction permettant de rafraichir la matrice
     digitalWrite(RST, HIGH);digitalWrite(RST, LOW);                                                             // Reset du 4017 du module 7x10 R click
     for (byte i = 0 ; i < 7; i++){                                                                              // Boucle générant 7 coups d'horloge sur le 4017 
     digitalWrite(CS0, LOW);                                                                                     // Sélection broche CSO    
     SPI.transfer(Matrice[0][i]); SPI.transfer(Matrice[1][i]);                                                   // Envoi les données aux matrices
     digitalWrite(CS0, HIGH);delay(3);                                                                           // Dé-sélection de la broche CS0 
     digitalWrite(MR, LOW);digitalWrite(MR, HIGH);                                                               // Vide le registre à décalage des 74HC595          
     digitalWrite(RCLK, HIGH);digitalWrite(RCLK, LOW);}                                                          // Coup d'horloge sur le 4017 du module 7x10 R click
     digitalWrite(CS0, LOW);SPI.transfer(Matrice[0][0]); SPI.transfer(Matrice[1][0]);digitalWrite(CS0, HIGH);}

void EffMatrice(byte MatriceD, byte MatriceG, byte D, byte G) {                                                  // Effacement matrice de droite
     for (byte i = 0 ; i < 7; i++){Matrice[0][i]=MScore[MatriceG][i];Matrice[1][i]=MScore[MatriceD][i];}         // Affiche motif sur les matrices
     for (byte j = 0 ; j < 7; j++){Matrice[D][j]=0b00011111;Matrice[G][j]=0b00011111;for (byte i = 0 ; i < 2; i++){Rmatrice();}  // Affiche ligne pleine
     Matrice[D][j]=0;Matrice[G][j]=0;for (byte i = 0 ; i < 2; i++){Rmatrice();}}                                                 // Efface la ligne
     for (byte i = 0 ; i < 50; i++){Rmatrice();}}                                         
             
void AffScore(byte MatriceD, byte MatriceG) {                                                                    // Fonction pour afficher le score
     for (byte i = 0 ; i < 7; i++){Matrice[0][i]=MScore[MatriceG][i];Matrice[1][i]=MScore[MatriceD][i];}         // Transfert de matrice pour affichage des scores
     for (byte i = 0 ; i < 30; i++){Rmatrice();}                                                                 // Affiche le score un instant
     for (byte i = 0 ; i < 7; i++) {Matrice[0][i]=0;Matrice[1][i]=0;}}                                           // Efface toutes les leds de la matrice
     
void CligneScore() {while(1){                                                                                    // Fonction pour faire clignoter le score
     for (byte i = 0 ; i < 7; i++) {Matrice[0][i]=MScore[ScoreJ2][i];Matrice[1][i]=MScore[ScoreJ1][i];}          // Transfert de matrice pour affichage des scores
     for (byte i = 0 ; i < 30; i++){Rmatrice();} for (byte i = 0 ; i < 7; i++) {Matrice[0][i]=0;Matrice[1][i]=0;}// Affiche le score un instant
     for (byte i = 0 ; i < 30; i++){Rmatrice();}}}                                                               // Affiche ecran vide un instant

     
