/* Utilisation du module MIKROE-1423
   Cette application va vous permettre de piloter un bargraph 10 leds
   à l'aide du module "BarGraph Click" (à mettre sur le support A de la platine "Flip & Click").
 
   CE PROGRAMME EST FOURNI «TEL QUEL», SANS GARANTIE D'AUCUNE SORTE, EXPLICITE OU
   IMPLICITE, Y COMPRIS MAIS SANS S'Y LIMITER LES GARANTIES DE QUALITÉ MARCHANDE,
   D'ADAPTATION À UN USAGE PARTICULIER ET D'ABSENCE DE CONTREFAÇON. EN AUCUN CAS, LA
   RESPONSABILITE DES AUTEURS OU DES DÉTENTEURS DE DROITS D'AUTEUR NE SERONT TENUS 
   RESPONSABLES DE TOUTE RECLAMATION, DOMMAGE OU AUTRE RESPONSABILITÉ, QUE CE SOIT
   DANS UNE ACTION DE CONTRAT, TORT OU AUTREMENT, PROVENANT DE, OU EN RELATION AVEC
   CE PROGRAMME OU L'UTILISATION OU AUTRES TRAITEMENTS DU PROGRAMME.
    
*/

#include <SPI.h>                         // Intégration de la librairie SPI
#define CS0 77                           // Attribution dusignal CS0 au port 77
byte SegmentA, SegmentB;                 // Variables pour la gestion des segments 1 à 8 (SegmentA) et 9 et 10 (SegmentB)
byte Valeur=0;                           // Variable de la valeur à afficher sur le bargraph

void setup() {
  pinMode(CS0, OUTPUT);                   // La broche CS0 est une sortie
  SPI.begin();                            // Initialiation du port SPI
}

void loop() {
  SegmentA = 0;                           // Initialisation des Segments A
  SegmentB = 0;                           // Initialisation des Segments B  
  for (byte i = 0 ; i < Valeur; i++){     // Sélectionne les Segments A à afficher en fonction de la variable Valeur
  bitWrite(SegmentA,i,1);}
  if (Valeur > 8) bitWrite(SegmentB,0,1); // Sélectionne les Segments B à afficher en fonction de la variable Valeur
  if (Valeur > 9) bitWrite(SegmentB,1,1); // Sélectionne les Segments B à afficher en fonction de la variable Valeur
  digitalWrite(CS0, LOW);                 // Sélection broche CSO 
  SPI.transfer(SegmentB);                 // Envoie les données des Segments B 
  SPI.transfer(SegmentA);                 // Envoie les données des Segments A
  digitalWrite(CS0, HIGH);                // Désélectionn broche CS0

  Valeur++;                               // Incrémente la valeur à afficher sur le bargraph
  if (Valeur==11) Valeur=0;               // Si Valeur > 10 -> Valeur = 0
  delay(80);                              // Temporisation 80 milli-secondes
}
