/* Utilisation du module MIKROE-2153
   Cette application va vous permettre de réaliser un jeu de roulette electronique
   à l'aide du module "LED ring R Click" (à mettre sur le support A de la platine "Flip & Click").
  
   CE PROGRAMME EST FOURNI «TEL QUEL», SANS GARANTIE D'AUCUNE SORTE, EXPLICITE OU
   IMPLICITE, Y COMPRIS MAIS SANS S'Y LIMITER LES GARANTIES DE QUALITÉ MARCHANDE,
   D'ADAPTATION À UN USAGE PARTICULIER ET D'ABSENCE DE CONTREFAÇON. EN AUCUN CAS, LA
   RESPONSABILITE DES AUTEURS OU DES DÉTENTEURS DE DROITS D'AUTEUR NE SERONT TENUS 
   RESPONSABLES DE TOUTE RECLAMATION, DOMMAGE OU AUTRE RESPONSABILITÉ, QUE CE SOIT
   DANS UNE ACTION DE CONTRAT, TORT OU AUTREMENT, PROVENANT DE, OU EN RELATION AVEC
   CE PROGRAMME OU L'UTILISATION OU AUTRES TRAITEMENTS DU PROGRAMME.
    
*/

#include <SPI.h>                                   // Intégration de la librairie SPI
#define CS0 77                                     // Attribution dusignal CS0 au port 77
byte Segment1=128, Segment2=0;                     // Variables pour la gestion des segments 1 et 2 du cercle
byte Segment3=0, Segment4=0;                       // Variables pour la gestion des segments 3 et 4 du cercle
int Rotation,Compteur=0;                           // Variables gérant la rotation de la roulette
int Temporisation = 15;                            // Variable gérant la vitesse de la roulette

void setup() {
  pinMode(CS0, OUTPUT);                            // La broche CS0 est une sortie
  SPI.begin();                                     // Initialiation du port SPI
  randomSeed(analogRead(0));                       // Réinitialise la séquence aléatoire
}

void loop() {
Rotation=random (160,193);                         // Choisi la position aléatoire où la roulette doit stopper
do
{
   digitalWrite(CS0, LOW);                          // Sélection broche CSO 
   SPI.transfer(Segment1);                          // Envoie les données du 1 er segment
   SPI.transfer(Segment2);                          // Envoie les données du 2 ème segment
   SPI.transfer(Segment3);                          // Envoie les données du 3 ème segment
   SPI.transfer(Segment4);                          // Envoie les données du 4 ème segment
   digitalWrite(CS0, HIGH);                         // Désélectionn la broche CS0 
   Segment1=Segment1>>1;                            // Décalage des bits du segment 1
   Segment2=Segment2>>1;                            // Décalage des bits du segment 2
   Segment3=Segment3>>1;                            // Décalage des bits du segment 3
   Segment4=Segment4>>1;                            // Décalage des bits du segment 4
   delay(Temporisation);                            // Temporisation pour gestion de la vitesse de la roulette
   Temporisation++;                                 // Augmente la durée de la temporisation (la roulette ralentie)
   Compteur++; Rotation--;                          // Incrémente nombre de pas de la roulette
   if (Compteur==8)  {Segment4=128;}                // Teste passage fin du 1er segment
   if (Compteur==16) {Segment3=128;}                // Teste passage fin du 2eme segment
   if (Compteur==24) {Segment2=128;}                // Teste passage fin du 3ème segment
   if (Compteur==32) {Segment1=128;Compteur=0;}     // Teste passage fin du 4ème segment
  } while (Rotation > 0);
  while(1){}                                        // La roulette s'est arrettée -> Boucle sans fin           
}
